<?php

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: POST, GET');
header('Content-Type: application/json; charset=utf-8');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

require 'include/connection.php';
include("systemlogs/system_logs.php");

function sendMail($data)
{

    $ch = curl_init();

    curl_setopt($ch, CURLOPT_URL, "https://mailapi.ozonedesk.com/send_email/api.php");
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data, '', '&'));

    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    $response = curl_exec($ch);

    curl_close($ch);

    return $response;

}

try {

    // Assuming your JSON data is sent in the request body
    $json_data = file_get_contents('php://input');

    // Decode the JSON data
    $data = json_decode($json_data, true);

    $id = isset($data['id']) ? mysqli_real_escape_string($conn, $data['id']) : null;
    $invoiceno = isset($data['invoiceno']) ? mysqli_real_escape_string($conn, $data['invoiceno']) : null;
    $adminId = isset($data['adminId']) ? mysqli_real_escape_string($conn, $data['adminId']) : null;



    $image_path = "http://fc04.deviantart.net/fs71/f/2010/227/4/6/PNG_Test_by_Destron23.png";

            // vend_id
        // api_key
        // receiver_mail
        // mailContent
        // subject
        // mail_cc
        // mail_bcc
        // attachment
        // replayto
        // replaytosub
        // vender_email
        // vender_header

    // get client email
    $query = "SELECT * FROM clients WHERE c_id = '$id'";

    $result = mysqli_query($conn, $query);

    if (!$result) {
        throw new Exception(mysqli_error($conn));
    }

    $row = mysqli_fetch_assoc($result);

    $c_mail = $row["email"];

    // get invoice details
    $query_invoice = "SELECT * FROM invoice_details WHERE invoice_HID = '$invoiceno'";

    $result_invoice = mysqli_query($conn, $query_invoice);

    if (!$result_invoice) {
        throw new Exception(mysqli_error($conn));
    }

    $row_invoice = mysqli_fetch_assoc($result_invoice);

    $total = $row_invoice['total'];
    $date = $row_invoice['date'];

    $mailCont = "<h2 style='background-color: lightcoral; text-align: center;'>Invoice Reminder</h2> 
             <p>Dear Customer,</p>
             <p>This is a friendly reminder to pay your invoice. Please find the details below:</p>
             <table style='border-collapse: collapse; width: 100%;'>
                <tr>
                    <td style='border: 1px solid #ddd; padding: 8px;'>Invoice Number</td>
                    <td style='border: 1px solid #ddd; padding: 8px;'>$invoiceno</td>
                </tr>
                <tr>
                    <td style='border: 1px solid #ddd; padding: 8px;'>Date</td>
                    <td style='border: 1px solid #ddd; padding: 8px;'>$date</td>
                </tr>
                <tr>
                    <td style='border: 1px solid #ddd; padding: 8px;'>Amount</td>
                    <td style='border: 1px solid #ddd; padding: 8px;'>$total</td>
                </tr>
             </table>
             <p>Thank you for your prompt attention to this matter.</p>";

    $query_system = "SELECT * FROM system_setting";

    $result_system = mysqli_query($conn, $query_system);

    if (!$result_system) {
        throw new Exception(mysqli_error($conn));

    }

    $row_system = mysqli_fetch_assoc($result_system);

    $vender_id = $row_system['email_api_vend_id'];
    $client_id = $row_system['email_api_client_id'];
    $api_key = $row_system['email_api_key'];
    $vender_email = $row_system['email_api_vender_email'];
    $vender_header = $row_system['email_api_vender_header'];

    $postFileds = array(
        "vend_id" => $vender_id,
        "client_id" => $client_id,
        "api_key" => $api_key,
        "receiver_mail" => "kalana@sparkglobal.lk",
        "mailContent" => $mailCont,
        "subject" => "Invoice Payment Reminder",
        "vender_email" => "$vender_email",
        "vender_header" => "$vender_header"
    );

    $sms_details = sendMail($postFileds);

    $sms_details_array = json_decode($sms_details, true);

    // Extract status_code and msg_id
    $status_code = $sms_details_array['status'];
    $msg_id = $sms_details_array['msg'];

    //   systemlogs
    $client = $id;
    $date = date('Y-m-d H:i:s');
    $module = 'Invoice email reminder';
    $message = "Admin $adminId - Status Code: $status_code, Message : $msg_id";

    insertSystemLog($conn, $client, $date, $module, $message);

   

} catch (\Throwable $th) {
    $response = array(
        'error' => true,
        'message' => 'An unexpected error occurred.',
        'details' => $th->getMessage()
    );
    echo json_encode($response);
}

?>