<?php

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: POST, GET');
header('Content-Type: application/json; charset=utf-8');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

include("include/connection.php");
include("jwtvalidation/jwt_validation.php");
require 'secret_key.php';

try {
    if ($_SERVER['REQUEST_METHOD'] !== 'GET') {
        throw new Exception('Invalid request method');
    }

    //  Validate the JWT token
     $headers = apache_request_headers();
     $secretKey = $secret_Key;
     $decodedToken = validateJWT($headers, $secretKey);
     
    $query = "SELECT * FROM system_setting "; 
    
    $result = mysqli_query($conn, $query);

    $row_count = mysqli_num_rows($result);

    if ($row_count > 0) {

        $row = mysqli_fetch_assoc($result);

        $response = array('success' => true, 'system' => $row, 'message' => 'All the system setting data');
    } else {
        $response = array('success' => false, 'message' => 'No system data found');
    }

    echo json_encode($response);

} catch (Exception $e) {
    $response = array('success' => false, 'message' => $e->getMessage());
    echo json_encode($response);
}
?>

