<?php

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: POST, GET');
header('Content-Type: application/x-www-form-urlencoded; charset=utf-8');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

include ("include/connection.php");
include ("adminlogs/admin_logs.php");
include ("notification/client_notification.php");
include ("jwtvalidation/jwt_validation.php");
require 'secret_key.php';


try {
    if ($_SERVER['REQUEST_METHOD'] !== 'POST') {
        throw new Exception('Invalid request method');
    }

    $headers = apache_request_headers();
    $secretKey = $secret_Key;
    $decodedToken = validateJWT($headers, $secretKey);

    $userId = $decodedToken['user_id'];

    // Assuming your JSON data is sent in the request body
    $json_data = file_get_contents('php://input');

    // Decode the JSON data
    $data = json_decode($json_data, true);

    $id = isset($data['id']) ? mysqli_real_escape_string($conn, $data['id']) : null;
    $amount = isset($data['amount']) ? mysqli_real_escape_string($conn, $data['amount']) : null;
    $adminId = isset($data['adminId']) ? mysqli_real_escape_string($conn, $data['adminId']) : null;
    $remark = isset($data['remark']) ? mysqli_real_escape_string($conn, $data['remark']) : null;



    // Select the current balance
    $selectQuery = "SELECT * FROM clients WHERE `c_id` = '$id'";
    $selectResult = mysqli_query($conn, $selectQuery);

    $row_count = mysqli_num_rows($selectResult);

    if ($row_count === 1) {
        $client_data = mysqli_fetch_assoc($selectResult);

        // Update the current balance
        $currentBalance = $client_data['current_balance'];
        $updatedBalance = $currentBalance + $amount;

        $date = date('Y-m-d H:i:s');

        $updateQuery = "UPDATE clients SET `current_balance` = '$amount', low_bal_status = 0 WHERE `c_id` = '$id'";
        $updateResult = mysqli_query($conn, $updateQuery);


        $addTopupquery = "INSERT INTO topup_history (`datetime`, `current_balance`, `new_balance`, `topup`, `user_id`, `by`) VALUES ('$date', 0, '$amount', '$amount', '$id', '0')";

        $result = mysqli_query($conn, $addTopupquery);

        $accountquery = "INSERT INTO account_history (`datetime`, `current_balance`, `new_balance`, `cost`, `type`, `byID`, `whose`, `comment`) VALUES ('$date', 0, '$amount', '$amount', 'balanceAdjustment', '$id', '$id', '$remark')";

        $resultAccount = mysqli_query($conn, $accountquery);

        if ($updateResult && $result && $resultAccount) {
            $response = array('success' => true, 'client' => $client_data, 'message' => 'Balance updated successfully');

            $by = $userId;
            $date = date('Y-m-d H:i:s');
            $module = 'Adjusment Topup';
            $message = "Administrator $userId has been successfully updated the Topup balance of Rs. $amount for Client $id.";

            insertAdminLog($conn, $by, $date, $module, $message);

            // notification
            $title = 'Adjusment Topup';
            $date = date('Y-m-d H:i:s');
            $subtitle = "The top-up amount to $amount.";
            $avatar = 'TP';
            $client_id = $id;

            insertNotification($conn, $title, $date, $subtitle, $avatar, $client_id);
        } else {
            $response = array('success' => false, 'message' => 'Failed to update balance');
        }
    } else {
        // Authentication failed
        $response = array('success' => false, 'message' => 'Invalid user id');
    }

    echo json_encode($response);


} catch (Exception $e) {
    $response = array('success' => false, 'message' => $e->getMessage());
    echo json_encode($response);
}

?>