<?php

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: POST, GET');
header('Content-Type: application/x-www-form-urlencoded; charset=utf-8');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

include ("include/connection.php");
include ("adminlogs/admin_logs.php");
include ("notification/client_notification.php");
include ("jwtvalidation/jwt_validation.php");
require 'secret_key.php';


try {
    if ($_SERVER['REQUEST_METHOD'] !== 'POST') {
        throw new Exception('Invalid request method');
    }

    $headers = apache_request_headers();
    $secretKey = $secret_Key;
    $decodedToken = validateJWT($headers, $secretKey);

    $userId = $decodedToken['user_id'];


    // Assuming your JSON data is sent in the request body
    $json_data = file_get_contents('php://input');

    // Decode the JSON data
    $data = json_decode($json_data, true);

    $invoiceNo = isset($data['invoiceNo']) ? mysqli_real_escape_string($conn, $data['invoiceNo']) : null;
    $adminId = isset($data['adminId']) ? mysqli_real_escape_string($conn, $data['adminId']) : null;
    $id = isset($data['id']) ? mysqli_real_escape_string($conn, $data['id']) : null;


    $date = date('Y-m-d H:i:s');

    $updateQuery = "UPDATE clients SET productive_cli = 1 WHERE `c_id` = '$id'";
    $updateResult = mysqli_query($conn, $updateQuery);

    $updateinvoice_query = "UPDATE invoice_details set `status` = 'paid', `date` = '$date' WHERE `invoice_HID` = '$invoiceNo'";

    $updateinvoice_result = mysqli_query($conn, $updateinvoice_query);

    if ($updateinvoice_result) {
        $response = array('success' => true, 'message' => 'Balance updated successfully');

        $by = $userId;
        $date = date('Y-m-d H:i:s');
        $module = 'Update Invoice Status';
        $message = "Administrator $userId has successfully Changed status to paid for Invoice $invoiceNo.";

        insertAdminLog($conn, $by, $date, $module, $message);

    } else {
        $response = array('success' => false, 'message' => 'Failed to update balance');
    }


    echo json_encode($response);




} catch (Exception $e) {
    $response = array('success' => false, 'message' => $e->getMessage());
    echo json_encode($response);
}

?>