<?php

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: POST, GET');
header('Content-Type: application/json; charset=utf-8');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

include("include/connection.php");
include("adminlogs/admin_logs.php");
include("notification/client_notification.php");

try {
    if ($_SERVER['REQUEST_METHOD'] !== 'POST') {
        throw new Exception('Invalid request method');
    }

    // Assuming your JSON data is sent in the request body
    $json_data = file_get_contents('php://input');

    // Decode the JSON data
    $data = json_decode($json_data, true);

    $id = isset($data['id']) ? mysqli_real_escape_string($conn, $data['id']) : null;
    $senderId = isset($data['senderId']) ? mysqli_real_escape_string($conn, $data['senderId']) : null;
    $adminId = isset($data['adminId']) ? mysqli_real_escape_string($conn, $data['adminId']) : null;
    $clientId = isset($data['clientId']) ? mysqli_real_escape_string($conn, $data['clientId']) : null;
    $type = isset($data['type']) ? mysqli_real_escape_string($conn, $data['type']) : null;


    // Update trans_per_msg and promocost in clients table
    $updateClientQuery = "UPDATE sender_details SET `sender_id` = '$senderId', `type` = '$type' WHERE `s_id` = '$id'";
    $updateClientResult = mysqli_query($conn, $updateClientQuery);

    if ($updateClientResult) {
        $response = array('success' => true, 'message' => 'sender Id updated successfully');

        // admin login
        $by = $adminId;
        $date = date('Y-m-d H:i:s');
        $module = 'update sender Id';
        $message = "Administrator $adminId has successfully updated the senderId name for sender $senderId($id).";

        insertAdminLog($conn, $by, $date, $module, $message);

        // notification
        $title = 'Update Sender Id name';
        $date = date('Y-m-d H:i:s');
        $subtitle = "Updated the sender id name to $senderId .";
        $avatar = 'SI';
        $client_id = $clientId;

        insertNotification($conn, $title, $date, $subtitle, $avatar, $client_id);

    } else {
        $response = array('success' => false, 'message' => 'Failed to update promo and trans cost');
    }

    echo json_encode($response);

} catch (Exception $e) {
    $response = array('success' => false, 'message' => $e->getMessage());
    echo json_encode($response);
}

?>