<?php

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: POST, GET');
header('Content-Type: application/json; charset=utf-8');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

include ("include/connection.php");
include ("adminlogs/admin_logs.php");
include ("notification/client_notification.php");
include ("jwtvalidation/jwt_validation.php");
require 'secret_key.php';

try {
    if ($_SERVER['REQUEST_METHOD'] !== 'POST') {
        throw new Exception('Invalid request method');
    }

    $headers = apache_request_headers();
    $secretKey = $secret_Key;
    $decodedToken = validateJWT($headers, $secretKey);

    $userId = $decodedToken['user_id'];

    // Assuming your JSON data is sent in the request body
    $json_data = file_get_contents('php://input');

    // Decode the JSON data
    $data = json_decode($json_data, true);

    $id = isset($data['id']) ? mysqli_real_escape_string($conn, $data['id']) : null;
    $transCost = isset($data['transcost']) ? mysqli_real_escape_string($conn, $data['transcost']) : '';
    $promoCost = isset($data['promocost']) ? mysqli_real_escape_string($conn, $data['promocost']) : '';
    $adminId = isset($data['adminId']) ? mysqli_real_escape_string($conn, $data['adminId']) : null;


    // Update trans_per_msg and promocost in clients table
    $updateClientQuery = "UPDATE clients SET `trans_per_msg` = '$transCost', `promo_per_msg` = '$promoCost' WHERE `c_id` = '$id'";
    $updateClientResult = mysqli_query($conn, $updateClientQuery);

    $updateSenderQuery = "UPDATE sender_details SET `trans_per_msg` = '$transCost', `promo_per_msg` = '$promoCost' WHERE `client_id` = '$id'";
    $updateSenderResult = mysqli_query($conn, $updateSenderQuery);


    if ($updateClientResult && $updateSenderQuery) {
        $response = array('success' => true, 'message' => 'promo and trans cost updated successfully');

        // admin login
        $by = $userId;
        $date = date('Y-m-d H:i:s');
        $module = 'update promo and trans cost';
        $message = "Administrator $userId has successfully updated the update promo and trans cost for Client $id.";

        insertAdminLog($conn, $by, $date, $module, $message);

        // notification
        $title = 'Update Promo and trans cost';
        $date = date('Y-m-d H:i:s');
        $subtitle = "Updated the transactional cost to $transCost and the promotional cost to $promoCost.";
        $avatar = 'PT';
        $client_id = $id;

        insertNotification($conn, $title, $date, $subtitle, $avatar, $client_id);

    } else {
        $response = array('success' => false, 'message' => 'Failed to update promo and trans cost');
    }

    echo json_encode($response);

} catch (Exception $e) {
    $response = array('success' => false, 'message' => $e->getMessage());
    echo json_encode($response);
}

?>